package com.fp.persistence.pgeneral.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENECATALOGEQUIVALENCE*/
@Entity(name="TgeneCatalogEquivalence")
@Table(name="TGENECATALOGEQUIVALENCE")
public class TgeneCatalogEquivalence extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneCatalogEquivalence
*/
@Id
@Column(name="CATALOGCECODE" ,nullable=false, updatable=false)
private String pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* null
*/
private Integer recordversion;

@Column(name="DESCRIPTION", nullable=false)

/**
* null
*/
private String description;

/**Contructor por defecto*/
public TgeneCatalogEquivalence(){
}
/**Contructor de TgeneCatalogEquivalence
@param pPk Clave Primaria del entity
@param pDescription null
*/
public TgeneCatalogEquivalence(String pPk,String pDescription){
 this();
 pk=pPk;
 description=pDescription;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneCatalogEquivalence
*/
public static TgeneCatalogEquivalence find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneCatalogEquivalence obj = pEntityManager.find(TgeneCatalogEquivalence.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneCatalogEquivalence
@return El objeto que referencia a la Clave primaria de TgeneCatalogEquivalence
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneCatalogEquivalence
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneCatalogEquivalence
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneCatalogEquivalence))return false;
    TgeneCatalogEquivalence that = (TgeneCatalogEquivalence) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TgeneCatalogEquivalence
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TgeneCatalogEquivalence
*/
public Object createInstance(){
 TgeneCatalogEquivalence instance=new TgeneCatalogEquivalence();	
 return instance;
}
/**Clona la entidad TgeneCatalogEquivalence
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneCatalogEquivalence p=(TgeneCatalogEquivalence)this.clone();
  return p;
}
}
